// Copyright (c) 2015 HigPen Works (Kenichiro Matsuura / Yuki Tsukasa). All rights reserved.
#pragma once
#include "../Base/Game.h"

extern CMoverList StageList;
class CStage : public CMover {
public:
	static CMoverList& MoverList() { return StageList; }
};

extern CMoverList CameraList;
class CCamera : public CMover {
public:
	static CMoverList& MoverList() { return CameraList; }
};

extern CMoverList EffectList;
class CEffect : public CMover {
public:
	static CMoverList& MoverList() { return EffectList; }
	void Reset() {
		Texture=GetTexture(L"Effect.png");
		Scale=CVector(0.1f, 0.1f);
	}
};

extern CMoverList EnemyList;
class CEnemy : public CMover {
public:
	static CMoverList& MoverList() { return EnemyList; }
	void Reset() {
		Texture=GetTexture(L"Enemy.png");
		Scale=CVector(0.1f, 0.1f);
	}
};

extern CMoverList PlayerList;
class CPlayer : public CMover {
public:
	CVector OldPosition;
	static CMoverList& MoverList() { return PlayerList; }
	void Reset() {
		Texture=GetTexture(L"Player.png");
		Scale=CVector(0.1f, 0.1f);
	}
};

extern CMoverList ItemList;
class CItem : public CMover {
public:
	static CMoverList& MoverList() { return ItemList; }
	void Reset() {
		Texture=GetTexture(L"Item.png");
		Scale=CVector(0.1f, 0.1f);
	}
};

extern CMoverList BulletList;
class CBullet : public CMover {
public:
	static CMoverList& MoverList() { return BulletList; }
	void Reset() {
		Texture=GetTexture(L"Bullet.png");
		Scale=CVector(0.1f, 0.1f);
	}
};

extern CMoverList WeaponList;
class CWeapon : public CMover {
public:
	static CMoverList& MoverList() { return WeaponList; }
	void Reset() {
		Texture=GetTexture(L"Weapon.png");
		Scale=CVector(0.1f, 0.1f);
	}
};

extern CMoverList BlockList;
class CBlock : public CMover {
public:
	static CMoverList& MoverList() { return BlockList; }
	void Reset() {
		Texture=GetTexture(L"Block.png");
		Scale=CVector(0.1f, 0.1f);
	}
};

extern CMoverList TextList;
class CText : public CMover {
public:
	static CMoverList& MoverList() { return TextList; }
	void Reset() {
		wchar_t s[]=L"?.png";
		s[0]=Type;
		Texture=GetTexture(s);
		Scale=CVector(0.08f, 0.08f);
		Life=2;
	}
	void Move() {
		Life--;
	}
};

extern bool UseScore;
extern int Score;

