// Copyright (c) 2015 HigPen Works (Kenichiro Matsuura / Yuki Tsukasa). All rights reserved.
#pragma once

class CStage;

CStage* StageNewObject();
CStage* StageMoveObject();
CStage* StageTouch();
CStage* StageTouchObject();
CStage* StageHitObject();
CStage* StageHitEffect();
CStage* StageScore();

CStage* StageFall();
CStage* StageFloor();
CStage* StageJump();
CStage* StageJumpHeight();
CStage* StageJumpMultiple();
CStage* StageJumpParabola();
CStage* StageFloorDrop();
CStage* StageFloorSlide();
CStage* StageStepOn();
CStage* StageTrampoline();
CStage* StageItemPick();
CStage* StageItemStrongWeak();
CStage* StageItemThrow();
CStage* StageSling();
CStage* StageReboundScreen();
CStage* StageReboundBlock();
CStage* StagePushBlock();
CStage* StagePushItem();
CStage* StageCarryItem();
CStage* StageUnbreakableObstacle();
CStage* StageBreakableObstacle();
CStage* StageEnemyPursue();
CStage* StageEnemyEscape();
CStage* StageEnemyAttack();
CStage* StageTilt();

CStage* StageSlide();
CStage* StageInScreen();
CStage* StageScroll();
CStage* StageLayerScroll();
CStage* StageBulletBasic();
CStage* StageBulletHit();
CStage* StageBulletAiming();
CStage* StageBulletHoming();
CStage* StageBulletNWay();
CStage* StageBulletCircle();
CStage* StageBulletTurn();
CStage* StageBulletSplit();
CStage* StageBulletAccelerate();
CStage* StageWeaponBasic();
CStage* StageWeaponSingle();
CStage* StageEnemyBasic();
CStage* StageEnemyItem();
CStage* StagePullItem();
CStage* StageStraightLaser();
CStage* StageHomingLaser();
CStage* StageLock();
CStage* StageBomb();
CStage* StageBarrier();

CStage* StagePieceSlide();
CStage* StagePieceSwap();
CStage* StagePieceCarry();
CStage* StagePieceChain();
CStage* StagePieceChain2();
CStage* StagePieceLine();
CStage* StagePieceDrop();
CStage* StagePieceHarvest();
CStage* StagePieceLink();
CStage* StagePieceQuad();
CStage* StagePiecePile();
CStage* StageStamina();
CStage* StageAddScore();

CStage* StageWalk();
CStage* StageSword();
CStage* StageShakeSword();
CStage* StageEnemyShakeSword();
CStage* StageMaze();
CStage* StageSwitchMaze();
CStage* StageGauge();
CStage* StageEncounterRandom();
CStage* StageEncounterSymbol();
CStage* StageCommand();
CStage* StageEquipment();

CStage* StageSound();

static CStage* (*StageFunc[])()={
	// Stage1
	StageNewObject, StageMoveObject, 
	StageTouch, StageTouchObject, 
	StageHitObject, StageHitEffect, StageScore, 
	
	// Stage2
	StageFall, StageFloor, StageJump, 
	StageJumpHeight, StageJumpMultiple, StageJumpParabola, 
	StageFloorDrop, StageFloorSlide, StageStepOn, StageTrampoline, 
	StageItemPick, StageItemStrongWeak, StageItemThrow, StageSling, 
	StageReboundScreen, StageReboundBlock, 
	StagePushBlock, StagePushItem, StageCarryItem, 
	StageUnbreakableObstacle, StageBreakableObstacle, 
	StageEnemyPursue, StageEnemyEscape, StageEnemyAttack, 
	StageTilt, 

	// Stage3
	StageSlide, StageInScreen, StageScroll, StageLayerScroll, 
	StageBulletBasic, StageBulletHit, StageBulletAiming, StageBulletHoming, 
	StageBulletNWay, StageBulletCircle, 
	StageBulletTurn, StageBulletSplit, StageBulletAccelerate, 
	StageWeaponBasic, StageWeaponSingle, StageEnemyBasic, 
	StagePullItem, StageStraightLaser, StageHomingLaser, 
	StageLock, StageBomb, StageBarrier, 

	// Stage4
	StagePieceSlide, StagePieceSwap, StagePieceCarry, 
	StagePieceChain, StagePieceChain2, 
	StagePieceLine, StagePieceDrop, StagePieceHarvest, 
	StagePieceLink, StagePieceQuad, StagePiecePile, 
	StageStamina, StageAddScore, 

	// Stage5
	StageWalk, StageSword, StageShakeSword, StageEnemyShakeSword, 
	StageMaze, StageSwitchMaze, StageEncounterRandom, StageEncounterSymbol, 
	StageGauge, StageCommand, StageEquipment, 
	
	// Stage6
	StageSound,
};
static int StageCount=sizeof(StageFunc)/sizeof(StageFunc[0]);
